#define F_CPU 14745600																				//Frequenz
#define USART_BAUD_RATE 9600																	//Baudrate, standart 9600, bei Probemen weniger
#define USART_BAUD_SELECT (F_CPU/(USART_BAUD_RATE*16l)-1)
#define LOW(x) ((x)& 0xFF)																		// Makro zum Lowbyte Zugriff eines Word
#define HIGH(x) (((x)>> 8)& 0xFF)														// Makro zum Highbyte Zugriff eines Word


void USART_init(void) { 																			//serielle Schnittstelle initialisieren, S. 187 
	UBRR0H = HIGH(USART_BAUD_SELECT);														//Baudrate einstellen
	UBRR0L = LOW(USART_BAUD_SELECT);														//Baudrate einstellen
	UCSR0B = (1<<TXEN0) | (1<<RXEN0) | (1<<RXCIE0);  						//senden, empfangen, receiveint aktivieren
	UCSR0C = (1<<UCSZ00) | (1<<UCSZ01);													//Frame Format setzen: 8data, 1stop bit (1<<UPM01) = Even Parity	
} //USART_Init

void TWI_init(uint8_t adress) {
	TWAR= (adress);//| (1<< PC0);																	//3 Bit Adresse (Port C Pin 1-3) + general call 	[P 216]
	TWCR= (1<< TWINT)| (1<< TWEA)| (1<< TWEN)| (1<< TWIE);											//[P 213]
} //TWI_init

void SPI_init(void) {
	SPCR= (1<< SPIE)| (1<< SPE)| (1<< MSTR)| (1<< SPR0);
	//SPSR= (1<< SPI2X);
} //SPI_init

void EXTINT_init(void) {
	EICRA= (1<< ISC01)| (1<< ISC00);
	//EIMSK= (1<< INT0);
} //PCINT_init

void PCINT_init(void) {
	PCICR= (1<< PCIE2);
	PCMSK2= (1<< PCINT21)| (1<< PCINT20);
} //PCINT_init

void PWM_init(void) {
	//Statusled	
	TCNT0= 0x00;
	TIMSK0= (1<< TOIE0);
	TCCR0B= (1<< CS02)| (1<< CS00);
																			
	//Schrittmotorentakt
	//TCCR1A= (1<< COM1A0);      //16bit | (1<< COM1A1) (1<< WGM10)| 
	
	TCNT1= 0x0000;																						//Timer 0 setzen
	OCR1A= 0x001D;
	TIMSK1= (1<< OCIE1A);
	TCCR1B= (1<< CS10);																					//PS 1

	//Stromregelung
	TCCR2A= (1<< WGM21)| (1<< WGM20)| (1<< COM2B1);      											//8bit PWM, Fast, clear on compare
	TCNT2= 0x00;																					//Timer 0 setzen
	OCR2B= 0x00;																					//Output Compare	 (bei max (0xFF) u-> 2.969V I= U/R)
	TCCR2B=  (1<< CS20);
} //PWM_init																						// I= 3V/ 0.51Ohm* (OCR2B/ 255)
																									// OCR2B= 255* (I* 0.51Ohm/ 3V)
																									// fr verwendeten Treiber DC nur 2A!!!! -> OCR2B < 0x54
																									// fr Motoren:
																									// 		Einfachgetriebe:	OCR2B < 0x14
																									// 		Doppelgetriebe:		OCR2B < 0x29
																									// 		Vierfachgetriebe:	OCR2B < 0x54
																									// 0x00 -> 0.0110V -> 0.02A
																									// 0x14 -> 0.2448V -> 0.48A
																									// 0x29 -> 0.4896V -> 0.96A
																									// 0x4F -> 0,9180V -> 1.80A
																									// 0x54 -> 0,9792V -> 1.92A
																									// 0xFF -> 2,9690V -> 5.82A
